<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

function plugin_install()
{
  global $prefixeTable, $conf;

  $query = 'SHOW TABLES LIKE "' . $prefixeTable . 'stuffs"';
  $result = pwg_query($query);
  if (!mysql_fetch_row($result))
  {
    $q = 'CREATE TABLE `' . $prefixeTable . 'stuffs` (
`id` smallint(5) NOT NULL,
`pos` smallint(5) NOT NULL,
`name` text NOT NULL,
`descr` varchar(255) default NULL,
`type` varchar(255) NOT NULL,
`datas` longtext default NULL,
`users` varchar(255) default NULL,
`groups` varchar(255) default NULL,
`show_title` enum(\'true\',\'false\') NOT NULL,
`on_home` enum(\'true\',\'false\') NOT NULL,
`on_cats` enum(\'true\',\'false\') NOT NULL,
`on_picture` enum(\'true\',\'false\') NOT NULL,
`id_line` varchar(1) default NULL,
`width` smallint(9) default NULL,
PRIMARY KEY  (`id`),
KEY `on_home` (`on_home`),
KEY `on_cats` (`on_cats`),
KEY `on_picture` (`on_picture`)
) DEFAULT CHARSET=utf8;';
    pwg_query($q);
  
    $q = "INSERT INTO `" . $prefixeTable . "stuffs` (`id`, `pos`, `name`, `descr`, `type`, `datas`, `users`, `groups`, `show_title`, `on_home`, `on_cats`, `on_picture`, `id_line`, `width`) 
VALUES (0, 1, 'MainBlock', NULL, 'MainBlock', NULL, 'guest,generic,normal,admin,webmaster', NULL, 'true', 'true', 'true', 'true', NULL, NULL);";
    pwg_query($q);
  }
}

function plugin_activate()
{
  global $prefixeTable;

  // Check if upgrade is needed
  $query = 'SHOW FULL COLUMNS FROM ' . $prefixeTable . 'stuffs;';
  $result = array_from_query($query, 'Field');
  if ($result[5] == 'params')
  {
    upgrade_stuffs_from_17();
  }
}

function plugin_uninstall()
{
    global $prefixeTable;

	$q = 'DROP TABLE ' . $prefixeTable . 'stuffs;';
    pwg_query($q);
}

function upgrade_stuffs_from_17()
{
  global $prefixeTable, $conf;

  $query = 'ALTER TABLE ' . $prefixeTable . 'stuffs
MODIFY COLUMN name TEXT CHARACTER SET utf8 NOT NULL,
MODIFY COLUMN descr VARCHAR(255) CHARACTER SET utf8 default NULL,
MODIFY COLUMN type VARCHAR(255) CHARACTER SET utf8 NOT NULL,
MODIFY COLUMN params VARCHAR(255) CHARACTER SET utf8 default NULL,
MODIFY COLUMN datas LONGTEXT CHARACTER SET utf8 default NULL,
MODIFY COLUMN users VARCHAR(255) CHARACTER SET utf8 default NULL,
MODIFY COLUMN groups VARCHAR(255) CHARACTER SET utf8 default NULL,
DEFAULT CHARACTER SET utf8,
ADD show_title ENUM(\'true\',\'false\') NOT NULL,
ADD on_home ENUM(\'true\',\'false\') NOT NULL,
ADD on_cats ENUM(\'true\',\'false\') NOT NULL,
ADD on_picture ENUM(\'true\',\'false\') NOT NULL,
ADD id_line VARCHAR(1) default NULL,
ADD width SMALLINT(9) default NULL,
ADD INDEX (on_home),
ADD INDEX (on_cats),
ADD INDEX (on_picture);';

  pwg_query($query);
  
  $query = 'SELECT id, name, type, params, datas FROM ' . $prefixeTable . 'stuffs;';
  $result = pwg_query($query);
  
  $modules = array();
  while ($row = mysql_fetch_assoc($result))
  {
    if ($row['name'] != 'MainBlock')
    {
      $array = array();
      foreach (explode('///', $row['name']) as $name)
      {
        $a = explode(':', $name);
        array_push($array, '[lang='.substr($a[0],0,2).']'.$a[1].'[/lang]');
      }
      $new_name = implode("\r\n", $array);
    }
    else
    {
      $new_name = 'MainBlock';
    }

    if ($row['type'] == 'LastComs')
    {
      $datas = unserialize($row['datas']);
      $row['datas'] = serialize(array($datas[0], $datas[1], $datas[6], $datas[2], $datas[3]));
    }
  
    $params = explode(',', $row['params']);
    $params[4] = !empty($params[4]) ? '"'.$params[4].'"' : 'NULL';
    $params[5] = !empty($params[5]) ? $params[5] : 'NULL';

    $query = 'UPDATE ' . $prefixeTable . 'stuffs
SET
  name = "'. $new_name . '",
  datas = "' . addslashes($row['datas']) . '",
  show_title = "'. ($params[0] ? 'true' : 'false') .'",
  on_home = "'. ($params[1] ? 'true' : 'false') .'",
  on_cats = "'. ($params[2] ? 'true' : 'false') .'",
  on_picture = "'. ($params[3] ? 'true' : 'false') .'",
  id_line = '. $params[4] .',
  width = '. $params[5] .'
WHERE id = '.$row['id'].';';

    pwg_query($query);
  }

  $query = 'ALTER TABLE ' . $prefixeTable . 'stuffs DROP params;';
  pwg_query($query);

  if (isset($conf['Stuffs']))
  {
	  $q = 'DELETE FROM ' . CONFIG_TABLE . ' WHERE param="Stuffs" LIMIT 1;';
    pwg_query($q);
  }
}


?>